=== Documentation/CMakeLists.txt ===
install(FILES
  ibacm.md
  ibsrpdm.md
  libibcm.md
  libibverbs.md
  librdmacm.md
  rxe.md
  udev.md
  tag_matching.md
  ../README.md
  ../MAINTAINERS
  DESTINATION "${CMAKE_INSTALL_DOCDIR}")
