## rdma-core 17.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,8 +22,6 @@
 #      Produce static libraries along with the usual shared libraries.
 #  -DVERBS_PROVIDER_DIR='' (default /usr/lib.../libibverbs)
 #      Use the historical search path for providers, in the standard system library.
-#  -DKERNEL_DIR='.../linux' (default '')
-#      If set use the kernel UAPI headers from this kernel source tree.
 #  -DNO_COMPAT_SYMS=1 (default disabled)
 #      Do not generate backwards compatibility symbols in the shared
 #      libraries. This may is necessary if using a dynmic linker that does
@@ -48,11 +46,11 @@
 set(PACKAGE_NAME "RDMA")
 
 # See Documentation/versioning.md
-set(PACKAGE_VERSION "16.0")
+set(PACKAGE_VERSION "17.1")
 # When this is changed the values in these files need changing too:
 #   debian/libibverbs1.symbols
 #   libibverbs/libibverbs.map
-set(IBVERBS_PABI_VERSION "16")
+set(IBVERBS_PABI_VERSION "17")
 set(IBVERBS_PROVIDER_SUFFIX "-rdmav${IBVERBS_PABI_VERSION}.so")
 
 #-------------------------
@@ -249,6 +247,31 @@
  int main(int argc,const char *argv[]) { return foo(); }"
   HAVE_FUNC_ATTRIBUTE_ALWAYS_INLINE
   FAIL_REGEX "warning")
+
+# Linux __u64 is an unsigned long long
+CHECK_C_SOURCE_COMPILES("
+#include <linux/types.h>
+ int main(int argc,const char *argv[]) { __u64 tmp = 0; unsigned long long *tmp2 = &tmp; return *tmp2; }"
+  HAVE_LONG_LONG_U64
+  FAIL_REGEX "warning")
+
+if (NOT HAVE_LONG_LONG_U64)
+  # Modern Linux has switched to use ull in all cases, but to avoid disturbing
+  # userspace some platforms continued to use unsigned long by default. This
+  # define will cause kernel headers to consistently use unsigned long long
+  add_definitions("-D__SANE_USERSPACE_TYPES__")
+endif()
+
+# glibc and kernel uapi headers can co-exist
+CHECK_C_SOURCE_COMPILES("
+ #include <sys/socket.h>
+ #include <netinet/in.h>
+ #include <linux/in.h>
+ #include <linux/in6.h>
+ int main(int argc,const char *argv[]) { return 0; }"
+  HAVE_GLIBC_UAPI_COMPAT)
+RDMA_DoFixup("${HAVE_GLIBC_UAPI_COMPAT}" "linux/in.h")
+RDMA_DoFixup("${HAVE_GLIBC_UAPI_COMPAT}" "linux/in6.h")
 
 # Provide a shim if C11 stdatomic.h is not supported.
 if (NOT HAVE_SPARSE)
@@ -307,31 +330,3 @@
       set(NL_INCLUDE_DIRS ${NL1_INCLUDE_DIRS})
       set(NL_LIBRARIES ${NL1_LIBRARIES})
     else()
-      message(FATAL_ERROR "Cannot find libnl-3.0 or libnl-1")
-    endif()
-  endif()
-
-  include_directories(${NL_INCLUDE_DIRS})
-else()
-  set(NL_KIND 0)
-  set(NL_LIBRARIES "")
-endif()
-
-# Older stuff blows up if these headers are included together
-if (NOT NL_KIND EQUAL 0)
-  set(SAFE_CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES}")
-  set(CMAKE_REQUIRED_INCLUDES "${NL_INCLUDE_DIRS}")
-  CHECK_C_SOURCE_COMPILES("
-#include <netlink/route/link.h>
-#include <net/if.h>
- int main(int argc,const char *argv[]) {return 0;}"
-    HAVE_WORKING_IF_H)
-  set(CMAKE_REQUIRED_INCLUDES "${SAFE_CMAKE_REQUIRED_INCLUDES}")
-endif()
-
-# udev
-find_package(UDev)
-include_directories(${UDEV_INCLUDE_DIRS})
-
-# Statically determine sizeof(long), this is largely unnecessary, no new code
-# should rely on this.
