=== libibumad/man/CMakeLists.txt ===
rdma_man_pages(
  umad_addr_dump.3
  umad_alloc.3
  umad_class_str.3
  umad_close_port.3
  umad_debug.3
  umad_dump.3
  umad_free.3
  umad_get_ca.3
  umad_get_ca_portguids.3
  umad_get_cas_names.3
  umad_get_fd.3
  umad_get_issm_path.3
  umad_get_mad.3
  umad_get_mad_addr.3
  umad_get_pkey.3
  umad_get_port.3
  umad_init.3
  umad_open_port.3
  umad_poll.3
  umad_recv.3
  umad_register.3
  umad_register2.3
  umad_register_oui.3
  umad_send.3
  umad_set_addr.3
  umad_set_addr_net.3
  umad_set_grh.3
  umad_set_grh_net.3
  umad_set_pkey.3
  umad_size.3
  umad_status.3
  umad_unregister.3
  )
rdma_alias_man_pages(
  umad_class_str.3 umad_attribute_str.3
  umad_class_str.3 umad_mad_status_str.3
  umad_class_str.3 umad_method_str.3
  umad_get_ca.3 umad_release_ca.3
  umad_get_port.3 umad_release_port.3
  umad_init.3 umad_done.3
  )
