=== providers/hfi1verbs/CMakeLists.txt ===
rdma_provider(hfi1verbs
  hfiverbs.c
  verbs.c
  )
