=== providers/nes/CMakeLists.txt ===
rdma_provider(nes
  nes_umain.c
  nes_uverbs.c
)
