=== providers/mlx5/man/CMakeLists.txt ===
rdma_man_pages(
  mlx5dv_get_clock_info.3
  mlx5dv_init_obj.3
  mlx5dv_query_device.3
  mlx5dv_ts_to_ns.3
  mlx5dv.7
)
