=== debian/changelog ===
rdma-core (17.1-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Mon, 19 Mar 2018 13:32:31 +0100

rdma-core (17.0-1) unstable; urgency=medium

  * New upstream release
    - Remove the obsolete libibcm library
  * Update private libibverbs symbols and let libibverbs1 break
    ibverbs-providers < 17~
  * Update copyright for kernel-headers directory

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Mon, 19 Feb 2018 12:47:42 +0100

rdma-core (16.2-1) unstable; urgency=medium

  * New upstream bugfix release
  * Guard udevadm call again
  * Override intentional systemd WantedBy= relationship lintian warning

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Thu, 15 Feb 2018 11:41:14 +0100

rdma-core (16.1-2) unstable; urgency=medium

  * Do not require valgrind on ia64 (Closes: #887511)

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Fri, 19 Jan 2018 12:37:05 +0100

rdma-core (16.1-1) unstable; urgency=medium

  * New upstream bugfix release.
  * Bump Standards-Version to 4.1.3 (no changes needed)
  * Add udev dependency to rdma-core and srptools

 -- Benjamin Drung <benjamin.drung@profitbricks.com>  Thu, 04 Jan 2018 14:42:26 +0100
