=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,8 @@
 			-DCMAKE_INSTALL_LIBEXECDIR:PATH=/usr/lib \
 			-DCMAKE_INSTALL_SHAREDSTATEDIR:PATH=/var/lib \
 			-DCMAKE_INSTALL_RUNDIR:PATH=/run \
-			-DCMAKE_INSTALL_UDEV_RULESDIR:PATH=/lib/udev/rules.d
+			-DCMAKE_INSTALL_UDEV_RULESDIR:PATH=/lib/udev/rules.d \
+			$(EXTRA_CMAKE_FLAGS)
 
 override_dh_auto_build:
 	ninja -C build-deb -v
